
#ifndef REGISTERS_H
#define REGISTERS_H

#define	RON_0		0
#define	RON_1		1
#define	RON_2		2
#define	RON_3		3
#define	RON_4		4
#define	RON_5		5
#define	RON_6		6
#define	RON_7		7
#define	IR_0		8
#define	IR_1		9
#define	IR_2		10
#define	IR_3		11
#define	IR_4		12
#define	IR_5		13
#define	IR_6		14
#define	IR_7		15
#define	PLLCR		16
#define	PLLSTR		17
#define	PLLTMCR		18
#define	SWCH0_CTRL	19
#define	SWCH1_CTRL	20
#define	SWCH2_CTRL	21
#define	SWCH3_CTRL	22
#define	ST0PRDR		23
#define	ST1PRDR		24
#define	ST2PRDR		25
#define	ST3PRDR		26
#define	ST0CR		27
#define	ST1CR		28
#define	ST2CR		29
#define	ST3CR		30
#define	ST0VAL		32
#define	ST1VAL		33
#define	ST2VAL		34
#define	ST3VAL		35
#define	DTC_CTRL	40
#define	DTC_ST		41
#define	DTC_IMASK0	42
#define	DTC_IMASK1	43
#define	DTC_DATA	44
#define	DTC_S_ADDR	45
#define	DTC_D_ADDR	46
#define	ROM_CTRL	47
#define	PSW			48
#define	INTR		49
#define	MSKR		50
#define	ER			51
#define	IRETADDR	52
#define	FORCE		53
#define	IHOOKADDR	55
#define	INTNUMR		56
#define	CURRENTADDR	59
#define	NEWADDR		60
#define	LASTPSW		61
#define	DFADDR		62
#define	ICR			63
/*

	Thread-safe reading from #reg_num
	Function ignores #31,#36,#37,#38,#39,#54,#57,#58

*/

void getq(unsigned reg_num, unsigned * highpc, unsigned * lowpc);

/*

	Thread-safe writing to #reg_num
	Function ignores #31,#36,#37,#38,#39,#54,#57,#58

*/

void setq(unsigned reg_num, unsigned   highpc, unsigned   lowpc);

#endif

