.include "aliases.inc"

.text
;void vPortRestoreContext(void)
;Восстановление контекста с возвратом в вызывающего (и подменой адреса возврата из ISR)
.global vPortRestoreContext
vPortRestoreContext:
                    rdl     #SP
                    jmp     @1
    
    pxTopOfStack:=  rdl [pxCurrentTCB]  ; *pxCurrentTCB -- это УКАЗАТЕЛЬ!
    
    reg_psw     :=  rdl @pxTopOfStack, 12
    reg0        :=  rdl @pxTopOfStack, 16
    reg1        :=  rdl @pxTopOfStack, 20
    reg2        :=  rdl @pxTopOfStack, 24
    reg3        :=  rdl @pxTopOfStack, 28
    reg4        :=  rdl @pxTopOfStack, 32
    reg5        :=  rdl @pxTopOfStack, 36
    reg6        :=  rdl @pxTopOfStack, 40
    reg7        :=  rdl @pxTopOfStack, 44
    reg8        :=  rdl @pxTopOfStack, 48
    reg9        :=  rdl @pxTopOfStack, 52
    reg10       :=  rdl @pxTopOfStack, 56
    reg11       :=  rdl @pxTopOfStack, 60
    reg12       :=  rdl @pxTopOfStack, 64
    reg13       :=  rdl @pxTopOfStack, 68
    reg_bp      :=  rdl @pxTopOfStack, 72
    reg_sp      :=  rdl @pxTopOfStack, 76
    ret_addr    :=  rdl @pxTopOfStack, 80
    
                    andl @reg_psw, 0xFFFFFFFE   ;Чтобы при восстановлении контекста из обработчика, не включились прерывания
                    setl #PSW,  @1
                    setl #0,    @reg0   
                    setl #1,    @reg1   
                    setl #2,    @reg2   
                    setl #3,    @reg3   
                    setl #4,    @reg4   
                    setl #5,    @reg5   
                    setl #6,    @reg6   
                    setl #7,    @reg7   
                    setl #8,    @reg8   
                    setl #9,    @reg9   
                    setl #10,   @reg10  
                    setl #11,   @reg11  
                    setl #12,   @reg12  
                    setl #13,   @reg13  
                    wrl  @reg_bp,   master.isr.bp
                    wrl  @reg_sp,   master.isr.sp  
                    wrl  @ret_addr, master.isr.retaddr

                    complete


;void vPortSaveContext(void)
;Сохранение контекста с возвратом в вызывающего
.global vPortSaveContext
vPortSaveContext:
                    rdl     #SP
                    jmp     @1
    
    pxTopOfStack:=  rdl [pxCurrentTCB]  ; *pxCurrentTCB -- это УКАЗАТЕЛЬ!
    
                    getl #PSW
    reg_psw     :=  orl  @1, 0x00000001
    reg0        :=  getl #0
    reg1        :=  getl #1 
    reg2        :=  getl #2
    reg3        :=  getl #3
    reg4        :=  getl #4
    reg5        :=  getl #5
    reg6        :=  getl #6
    reg7        :=  getl #7
    reg8        :=  getl #8
    reg9        :=  getl #9
    reg10       :=  getl #10
    reg11       :=  getl #11
    reg12       :=  getl #12
    reg13       :=  getl #13
    reg_bp      :=  rdl  master.isr.bp
    reg_sp      :=  rdl  master.isr.sp
    ret_addr    :=  rdl  master.isr.retaddr
    
                    wrl @reg_psw,   @pxTopOfStack, 12
                    wrl @reg0,      @pxTopOfStack, 16
                    wrl @reg1,      @pxTopOfStack, 20
                    wrl @reg2,      @pxTopOfStack, 24
                    wrl @reg3,      @pxTopOfStack, 28
                    wrl @reg4,      @pxTopOfStack, 32
                    wrl @reg5,      @pxTopOfStack, 36
                    wrl @reg6,      @pxTopOfStack, 40
                    wrl @reg7,      @pxTopOfStack, 44
                    wrl @reg8,      @pxTopOfStack, 48
                    wrl @reg9,      @pxTopOfStack, 52
                    wrl @reg10,     @pxTopOfStack, 56
                    wrl @reg11,     @pxTopOfStack, 60
                    wrl @reg12,     @pxTopOfStack, 64
                    wrl @reg13,     @pxTopOfStack, 68
                    wrl @reg_bp,    @pxTopOfStack, 72
                    wrl @reg_sp,    @pxTopOfStack, 76
                    wrl @ret_addr,  @pxTopOfStack, 80
    
                    complete


;void PRS(void)
;Начальное "восстановление" контекста с переходом в задачу
.global PRS
PRS:
    pxTopOfStack:=  rdl [pxCurrentTCB]  ; *pxCurrentTCB -- это УКАЗАТЕЛЬ!
    
    reg_psw     :=  rdl @pxTopOfStack, 12
    reg0        :=  rdl @pxTopOfStack, 16
    reg1        :=  rdl @pxTopOfStack, 20
    reg2        :=  rdl @pxTopOfStack, 24
    reg3        :=  rdl @pxTopOfStack, 28
    reg4        :=  rdl @pxTopOfStack, 32
    reg5        :=  rdl @pxTopOfStack, 36
    reg6        :=  rdl @pxTopOfStack, 40
    reg7        :=  rdl @pxTopOfStack, 44
    reg8        :=  rdl @pxTopOfStack, 48
    reg9        :=  rdl @pxTopOfStack, 52
    reg10       :=  rdl @pxTopOfStack, 56
    reg11       :=  rdl @pxTopOfStack, 60
    reg12       :=  rdl @pxTopOfStack, 64
    reg13       :=  rdl @pxTopOfStack, 68
    reg14       :=  rdl @pxTopOfStack, 72
    reg15       :=  rdl @pxTopOfStack, 76
    ret_addr    :=  rdl @pxTopOfStack, 80
    
                    jmp  @ret_addr
    
                    setl #PSW,  @reg_psw
                    setl #0,    @reg0   
                    setl #1,    @reg1   
                    setl #2,    @reg2   
                    setl #3,    @reg3   
                    setl #4,    @reg4   
                    setl #5,    @reg5   
                    setl #6,    @reg6   
                    setl #7,    @reg7   
                    setl #8,    @reg8   
                    setl #9,    @reg9   
                    setl #10,   @reg10  
                    setl #11,   @reg11  
                    setl #12,   @reg12  
                    setl #13,   @reg13  
                    setl #14,   @reg14  
                    setl #15,   @reg15  

                    complete

;void sysTimerHandler()
;{
;	portSAVE_CONTEXT();

;	if( xTaskIncrementTick() != pdFALSE )
;	{
;		vTaskSwitchContext();
;	}
;	portRESTORE_CONTEXT();
;}

;void vPortYield( void )
;Ручное переключение задачи
.global vPortYield
vPortYield:
    jmp     vPortYield.P2
    getl    #PSW
    andl    @1, 0xFFFFFFFE  ; Выкл. прерывания
    setl    #PSW,   @1
    complete

vPortYield.P2:
    ;Сохраняем контекст
    pxTopOfStack:=  rdl [pxCurrentTCB]  ; *pxCurrentTCB -- это УКАЗАТЕЛЬ!
                    
                    getl #PSW
    reg_psw     :=  orl  @1, 0x00000001 ; Считаем, что в задаче прерывания всегда вкл.
    reg0        :=  getl #0
    reg1        :=  getl #1 
    reg2        :=  getl #2
    reg3        :=  getl #3
    reg4        :=  getl #4
    reg5        :=  getl #5
    reg6        :=  getl #6
    reg7        :=  getl #7
    reg8        :=  getl #8
    reg9        :=  getl #9
    reg10       :=  getl #10
    reg11       :=  getl #11
    reg12       :=  getl #12
    reg13       :=  getl #13
    reg_bp      :=  getl #14
    reg_sp      :=  getl #15
    ret_addr    :=  rdl  #SP
    
                    wrl @reg_psw,   @pxTopOfStack, 12
                    wrl @reg0,      @pxTopOfStack, 16
                    wrl @reg1,      @pxTopOfStack, 20
                    wrl @reg2,      @pxTopOfStack, 24
                    wrl @reg3,      @pxTopOfStack, 28
                    wrl @reg4,      @pxTopOfStack, 32
                    wrl @reg5,      @pxTopOfStack, 36
                    wrl @reg6,      @pxTopOfStack, 40
                    wrl @reg7,      @pxTopOfStack, 44
                    wrl @reg8,      @pxTopOfStack, 48
                    wrl @reg9,      @pxTopOfStack, 52
                    wrl @reg10,     @pxTopOfStack, 56
                    wrl @reg11,     @pxTopOfStack, 60
                    wrl @reg12,     @pxTopOfStack, 64
                    wrl @reg13,     @pxTopOfStack, 68
                    wrl @reg_bp,    @pxTopOfStack, 72
                    wrl @reg_sp,    @pxTopOfStack, 76
                    wrl @ret_addr,  @pxTopOfStack, 80
                    
                    ;Просим ОС переключить задачу
                    jmp vTaskSwitchContext  ; vTaskSwitchContext()
                    getl PRS                ; После "возврата" будет переход на PRS, которая перебросит в нужное место
                    wrl @1, #SP
                    complete

;void vPortTaskExit()
;Аварийный выход для задачи
.global vPortTaskExit
vPortTaskExit:
    jmp     vPortTaskExit
    setl    #0, 0x01ABCDEF
    setl    #1, 0xDEADBEEF
    complete
