#include "FreeRTOS.h"
#include "task.h"
#include "portmacro.h"
#include "registers.h"
//#include <tim.h>
#include <irq.h>

volatile uint32_t ulCriticalNesting = 0;

extern void initSysTimer(unsigned int prescaler, unsigned int period);
extern void vPortDisableInterrupts();
extern void vPortEnableInterrupts();
extern void vPortRestoreContext(void);//extern volatile void * volatile pxCurrentTCB; extern volatile uint32_t ulCriticalNesting;
extern void vPortSaveContext(void);//extern volatile void * volatile pxCurrentTCB; extern volatile uint32_t ulCriticalNesting;
extern void PRS();
extern void vPortTaskExit();
void sysTimerHandler(void);

/*-----------------------------------------------------------*/
//void portable_init(void){
//	set_irq_vector(sysTimerHandler, IRQ_GPTIM0);
//	setq(MSKR, 0, 1<<IRQ_GPTIM0);
//}

/*-----------------------------------------------------------*/

/* We require the address of the pxCurrentTCB variable, but don't want to know
any details of its type. */
//typedef void tskTCB;
//extern struct tskTCB * volatile pxCurrentTCB;
//
///*-----------------------------------------------------------*/
//
///* 
// * See header file for description. 
// */
portSTACK_TYPE *pxPortInitialiseStack( portSTACK_TYPE *pxTopOfStack, TaskFunction_t pxCode, void *pvParameters )
{
/*	Инициализация стека и указателей стека:
	    0           #SP      #BP = sizeof.DM
	    |           |        |
	    v           v        v
	DM |...........|....|....|
	                     ^^^^
	                ^^^^ param
	                #ret_addr
	#SP -- адрес возврата из программы;
	#BP -- за верхнюю границу DM.
*/
//unsigned int usAddress;
	*pxTopOfStack = ( portSTACK_TYPE ) pxCode;
	pxTopOfStack --;

	*pxTopOfStack = ( portSTACK_TYPE )(pxTopOfStack - 19);	// #15 (SP)
	pxTopOfStack --;

	*pxTopOfStack = ( portSTACK_TYPE )(pxTopOfStack - 17);	// #14 (BP)
	pxTopOfStack --;
	/*#13... #0*/
	pxTopOfStack -=14;

	*pxTopOfStack = ( portSTACK_TYPE ) 0x00000001;		// <-- BP  #PSW
	pxTopOfStack --;

	*pxTopOfStack = ( portSTACK_TYPE ) pvParameters;	// Параметры вызова функции
	pxTopOfStack --;
	
	*pxTopOfStack = ( portSTACK_TYPE ) vPortTaskExit;	// <-- SP  Вообще, выход -- ситуация аварийная
	pxTopOfStack --;
//
//	usAddress = ( unsigned int ) pxCode;
//	*pxTopOfStack = ( portSTACK_TYPE ) usAddress ;
//	pxTopOfStack--;
//
//	*pxTopOfStack = (int)pvParameters;
//	pxTopOfStack--;
//
//	*pxTopOfStack = 0xA0;
//	pxTopOfStack--;
//
//	*pxTopOfStack = 0xA1;
//	pxTopOfStack--;
//
//	*pxTopOfStack = 0xA2;
//	pxTopOfStack--;
//
//	*pxTopOfStack = 0xA3;
//	pxTopOfStack--;
//
//	*pxTopOfStack = 0xA4;
//	pxTopOfStack--;
//
//	*pxTopOfStack = 0xA5;
//	pxTopOfStack--;
//
//	*pxTopOfStack = 0xA6;
//	pxTopOfStack--;
//
//	*pxTopOfStack = 0xA7;
//	
//	pxTopOfStack--;  
//
//	*pxTopOfStack = (int)pvParameters;  // pvParameters выполняемой задачи.
//
//	pxTopOfStack--;  
//
//	*pxTopOfStack = 0x0;                // Адрес уходы в случае ошибки.
//
//	pxTopOfStack--;    // <- +SIZE регистры и задача, -SIZE стек задачи
//				// Тут будет #BP задачи.
//
//
	return pxTopOfStack;
}
///*-----------------------------------------------------------*/
//#define portRESTORE_CONTEXT()											\
//{																		\
//extern volatile void * volatile pxCurrentTCB;							\
//extern volatile uint32_t ulCriticalNesting;					\
																		//\
	///* Set the LR to the task stack. */									\
	//__asm volatile (													\
	//"LDR		R0, =pxCurrentTCB								\n\t"	\
	//"LDR		R0, [R0]										\n\t"	\
	//"LDR		LR, [R0]										\n\t"	\
																		//\
	///* The critical nesting depth is the first item on the stack. */	\
	///* Load it into the ulCriticalNesting variable. */					\
	//"LDR		R0, =ulCriticalNesting							\n\t"	\
	//"LDMFD	LR!, {R1}											\n\t"	\
	//"STR		R1, [R0]										\n\t"	\
																		//\
	///* Get the SPSR from the stack. */									\
	//"LDMFD	LR!, {R0}											\n\t"	\
	//"MSR		SPSR, R0										\n\t"	\
																		//\
	///* Restore all system mode registers for the task. */				\
	//"LDMFD	LR, {R0-R14}^										\n\t"	\
	//"NOP														\n\t"	\
																		//\
	///* Restore the return address. */									\
	//"LDR		LR, [LR, #+60]									\n\t"	\
																		//\
	///* And return - correcting the offset in the LR to obtain the */	\
	///* correct address. */												\
	//"SUBS	PC, LR, #4											\n\t"	\
	//);																	\
	//( void ) ulCriticalNesting;											\
	//( void ) pxCurrentTCB;												\
//}
///*-----------------------------------------------------------*/

//#define portSAVE_CONTEXT()												\
//{																		\
//extern volatile void * volatile pxCurrentTCB;							\
//extern volatile uint32_t ulCriticalNesting;					\
																		//\
	///* Push R0 as we are going to use the register. */					\
	//__asm volatile (													\
	//"STMDB	SP!, {R0}											\n\t"	\
																		//\
	///* Set R0 to point to the task stack pointer. */					\
	//"STMDB	SP,{SP}^											\n\t"	\
	//"NOP														\n\t"	\
	//"SUB	SP, SP, #4											\n\t"	\
	//"LDMIA	SP!,{R0}											\n\t"	\
																		//\
	///* Push the return address onto the stack. */						\
	//"STMDB	R0!, {LR}											\n\t"	\
																		//\
	///* Now we have saved LR we can use it instead of R0. */				\
	//"MOV	LR, R0												\n\t"	\
																		//\
	///* Pop R0 so we can save it onto the system mode stack. */			\
	//"LDMIA	SP!, {R0}											\n\t"	\
																		//\
	///* Push all the system mode registers onto the task stack. */		\
	//"STMDB	LR,{R0-LR}^											\n\t"	\
	//"NOP														\n\t"	\
	//"SUB	LR, LR, #60											\n\t"	\
																		//\
	///* Push the SPSR onto the task stack. */							\
	//"MRS	R0, SPSR											\n\t"	\
	//"STMDB	LR!, {R0}											\n\t"	\
																		//\
	//"LDR	R0, =ulCriticalNesting								\n\t"	\
	//"LDR	R0, [R0]											\n\t"	\
	//"STMDB	LR!, {R0}											\n\t"	\
																		//\
	///* Store the new top of stack for the task. */						\
	//"LDR	R0, =pxCurrentTCB									\n\t"	\
	//"LDR	R0, [R0]											\n\t"	\
	//"STR	LR, [R0]											\n\t"	\
	//);																	\
	//( void ) ulCriticalNesting;											\
	//( void ) pxCurrentTCB;												\
//}


#if configUSE_PREEMPTION == 1

/*
 * Tick ISR for preemptive scheduler.  We can use a naked attribute as
 * the context is saved at the start of vPortYieldFromTick().  The tick
 * count is incremented after the context is saved.
 */
void sysTimerHandler()
{
	portSAVE_CONTEXT();

	if( xTaskIncrementTick() != pdFALSE )
	{
		vTaskSwitchContext();
	}

	portRESTORE_CONTEXT();

//	initSysTimer(0,TPERIOD,TPREDDIV);
}
#else

/*
 * Tick ISR for the cooperative scheduler.  All this does is increment the
 * tick count.  We don't need to switch context, this can only be done by
 * manual calls to taskYIELD();
 */
void sysTimerHandler()
{
	xTaskIncrementTick();
//	initSysTimer(0,TPERIOD,TPREDDIV);
}
#endif

/* Setting up the timer tick is hardware specific and thus in the portable interface. */
BaseType_t xPortStartScheduler( void ){
	/* Setup the hardware to generate the tick. */
	set_irq_vector(sysTimerHandler, IRQ_ST0);
	initSysTimer(portCLOCK_PER_MS, portTICK_PERIOD_MS);
	/* Restore the context of the first task that is going to run. */
	PRS();


	/* Should not get here. */
	return pdTRUE;	
}
void vPortEndScheduler( void ){}

void vPortEnterCritical( void )
{
	/* Disable interrupts */
	portDISABLE_INTERRUPTS();

	/* Now interrupts are disabled ulCriticalNesting can be accessed
	 directly.  Increment ulCriticalNesting to keep a count of how many times
	 portENTER_CRITICAL() has been called. */
	ulCriticalNesting++;
}

void vPortExitCritical( void )
{
	if(ulCriticalNesting > portNO_CRITICAL_NESTING)
	{
		ulCriticalNesting--;
		if( ulCriticalNesting == portNO_CRITICAL_NESTING )
		{
			/* Enable all interrupt/exception. */
			portENABLE_INTERRUPTS();
		}
	}
}


/***********************************************************************/
void memcpy(void * dest,const void * target,int size);
void memcpy(void * dest,const void * target,int size){
	int i=0;
	size--;
	while(i<size){
		*(((unsigned char*)dest)+i)=*(((unsigned char*)target)+i);
		i++;
	}
}

int memcmp ( const void* buf1, const void* buf2, size_t count ){
	if(!count)
        return(0);

    while(--count && *(char*)buf1 == *(char*)buf2 ) {
        buf1 = (char*)buf1 + 1;
        buf2 = (char*)buf2 + 1;
    }

    return(*((unsigned char*)buf1) - *((unsigned char*)buf2));
}

void * memset (void *_Dst, int _Val, unsigned _Size)
{
    unsigned char *buf = (unsigned char *)_Dst;
    while (_Size--)
    {
        *buf++ = (unsigned char)_Val;
    }
    return _Dst;
}
	
