.include "aliases.inc"
.include "HDL50001_pcf.inc"

.text

; void vPortEnableInterrputs()
.global vPortEnableInterrupts
vPortEnableInterrupts:
    rdl     #SP
    jmp     @1
    getl    #PSW
    orl     @1, 0x00000001          ;Set "interrupt enable" bit (0)
    setl    #PSW, @1
    complete

; void vPortDisableInterrputs()
.global vPortDisableInterrupts
vPortDisableInterrupts:
    jmp     vPortDisableInterrupts.P2
    getl    #PSW
    orl     @1, 0x00000100          ;Set "execution barrier" bit (8)
    setl    #PSW,@1
    complete

vPortDisableInterrupts.P2:
    rdl     #SP
    jmp     @1
    getl    #PSW
    andl    @1, 0xFFFFFEFE          ;Clear "interrupt enable" bit (0) and "Execution barrier" bit (8)
    setl    #PSW,@1
    complete


; void initSysTimer(unsigned int msec)
.global initSysTimer
.alias initSysTimer.prescaler   #SP, 4
.alias initSysTimer.period      #SP, 8
initSysTimer:
    jmp     initSysTimer.P2
    getl    #PSW
    orl     @1, 0x00000100          ;Set "execution barrier" bit (8)
    setl    #PSW,@1
    complete

initSysTimer.P2:
    jmp     initSysTimer.P3
    rdl     initSysTimer.period
    getl    #MSKR
    setl    #ST0PRDR, @2
    orl     @2, 0x00000100          ;Enable INT 8
    setl    #MSKR, @1
    complete

initSysTimer.P3:
    rdl     #SP
    jmp     @1

    rdl     initSysTimer.prescaler
    andl    @1, 0x00FFFFFF
    slll    @1, 8
    orl     @1, 0x00000003
    setl    #ST0CR, @1
    
    getl    #PSW
    andl    @1, 0xFFFFFEFF          ;Clear "execution barrier" bit (8)
    setl    #PSW,@1
    complete




